
package _SGML;
@ISA = qw( Fundamental );

####################################
# Class Variables

####################################
# Class Methods

####################################
# Instance Methods

sub _localize {
	#_DebugLog("Fund _localize\n");
	my($sub) = shift;
        my($this) = shift;
	# Setup some convenient aliases
	local(*curcol)  = \$this->{'curcol'};
	local(*trycol)  = \$this->{"trycol"};
        local(*curline) = \$this->{'curline'};
	local(*buffer)  =  $this->{'buffer'};
	local(*self)    = \$this;
        return &$sub(@_);
}

sub Initialize {
	my($self) = shift;
	$self->SUPER::Initialize;
}
###################
#SGML Movement

sub LookingAtTag { my($self) = shift; return $self->LookingAt("<"); }
sub _LookingAtTag { return $self->LookingAt("<"); }
sub LookingAtOpeningTag { my($self) = shift; return $self->LookingAt("<[^/]"); }
sub _LookingAtOpeningTag { return $self->LookingAt("<[^/]"); }
sub LookingAtClosingTag { my($self) = shift; return $self->LookingAt("</"); }
sub _LookingAtClosingTag { return $self->LookingAt("</"); }

sub FindNextTag { my($self) = shift; return $self->FindNextRE("<"); }
sub _FindNextTag { return $self->FindNextRE("<"); }
sub FindPrevTag { my($self) = shift; return $self->FindPrevRE("<"); }
sub _FindPrevTag { return $self->FindPrevRE("<"); }
sub FindNextOpeningTag { my($self) = shift; return $self->FindNextRE("<[^/]"); }
sub _FindNextOpeningTag { return $self->FindNextRE("<[^/]"); }
sub FindPrevOpeningTag { my($self) = shift; return $self->FindPrevRE("<[^/]"); }
sub _FindPrevOpeningTag { return $self->FindPrevRE("<[^/]"); }

sub BalanceAllUnmatchedTags { return _localize(\&_BalanceAllUnmatchedTags,@_); }
sub _BalanceAllUnmatchedTags {
	my(@EndOptional) = @_;
	while(&_BalanceLastUnmatchedTag(@EndOptional)){
		#&_DebugLog("$curline\n");
		$self->ShowMsg(sprintf "Completed: %.2f%%",
			($#buffer-$curline)/$#buffer*100);
	}
	$self->ShowMsg("Completed: 100.00%");
}

sub BalanceLastUnmatchedTag { return _localize(\&_BalanceLastUnmatchedTag,@_); }
sub _BalanceLastUnmatchedTag {
	my(@EndOptional) = @_;
	return 0 if(!&_FindLastUnmatchedTag(@EndOptional));
	my($tag)=&_GetOpeningTag;
	$self->MoveToBufferEnd if(!&_FindNextTag);
	$self->InsertString("</".$tag.">");
	$self->SplitLine;
	return 1;
}

sub FindLastUnmatchedTag { return _localize(\&_FindLastUnmatchedTag,@_); }
sub _FindLastUnmatchedTag {
	my(@EndOptional) = @_;
	my(@origpos)=($curline,$trycol,$curcol);

	$self->MoveToBufferEnd;
	while(1){
		if(!&_FindPrevOpeningTag){
			($curline,$trycol,$curcol)=@origpos;
			return 0;
		}
		return 1 if(!&_CanFindMatchingClosingTag(@EndOptional));
	}
}

sub FindMatchingTag { return _localize(\&_FindMatchingTag,@_); }
sub _FindMatchingTag {
	my(@EndOptional) = @_;
	&_FindPrevTag if(!&_LookingAtTag);
	return 0 if(!&_LookingAtTag);
	if(&_LookingAtClosingTag){
		return &_FindMatchingOpeningTag(@EndOptional);
	} else {
		return &_FindMatchingClosingTag(@EndOptional);
	}
}

sub CanFindMatchingClosingTag { return _localize(\&_CanFindMatchingClosingTag,@_); }
sub _CanFindMatchingClosingTag {
	my(@EndOptional) = @_;
	my(@origpos)=($curline,$trycol,$curcol);
	if(&_FindMatchingClosingTag(@EndOptional)){
		($curline,$trycol,$curcol)= @origpos;
		return 1;
	}
	return 0;
}

# takes a list of tags which may have legally omitted the closing tag
sub FindMatchingClosingTag { return _localize(\&_FindMatchingClosingTag,@_); }
sub _FindMatchingClosingTag {
	my(@EndOptional) = @_;
	my(@origpos)=($curline,$trycol,$curcol);
	my($openingtag)=&_GetOpeningTag;
#	$self->DebugLog("_FindMatchingClosingTag for $openingtag\n");
	while(1){
		&_FindNextTag;
		if(grep /(?i)^$openingtag/, @EndOptional){
			if(&_LookingAtOpeningTag ||
			   (&_LookingAtClosingTag &&
			    &_GetClosingTag ne $openingtag)){
#				$self->DebugLog("Success (no closing tag)\n");
				($curline,$trycol,$curcol)=@origpos;
				return 1;
			} else {
#				$self->DebugLog("Success (found optional closing tag)\n");
				return 1;
			}
		}
		if(&_LookingAtOpeningTag){
			my($nextopeningtag) = &_GetOpeningTag;
			last if(!&_FindMatchingClosingTag(@EndOptional));
			next;
		}
		if(&_LookingAtClosingTag){
			my($closingtag)=&_GetClosingTag;
			last if($openingtag ne $closingtag);
#			$self->DebugLog("Success\n");
			return 1; #success
		}
	}
	#Error
#	$self->DebugLog("Failed\n");
	($curline,$trycol,$curcol)=@origpos;
	return 0;
}
sub FindMatchingOpeningTag { return _localize(\&_FindMatchingOpeningTag,@_); }
sub _FindMatchingOpeningTag {
	my(@EndOptional) = @_;
	my(@origpos)=($curline,$trycol,$curcol);
        my($closingtag)=&_GetClosingTag;

        while(1){
                &_FindPrevTag;
                if(&_LookingAtClosingTag){
                        last if(!&_FindMatchingOpeningTag(@EndOptional));
                        next;
                }
                if(&_LookingAtOpeningTag){
                        my($openingtag)=&_GetOpeningTag;
#                        last if($openingtag ne $closingtag);
			if($openingtag ne $closingtag){
				next if(grep /(?i)^$openingtag/, @EndOptional);
				last;
			}
                        return 1; #success
		}
        }
        #Error
        ($curline,$trycol,$curcol)= @origpos;
        return 0;
}
sub GetOpeningTag { return _localize(\&_GetOpeningTag,@_); }
sub _GetOpeningTag {
	substr($buffer[$curline],$curcol) =~ m|<([^\s>]+)|;
	return uc($1);
}
sub GetClosingTag { return _localize(\&_GetClosingTag,@_); }
sub _GetClosingTag {
	substr($buffer[$curline],$curcol) =~ m|</([^\s>]+)|;
	return uc($1);
}

1;
